/*******Stata code  WID.world gpinter*****/

#delimit;
clear;
set more off;

cd "D:\Dropbox\WIDRussia\NPZ2017DistributionSeries\";

/*
/****Step 1: extracting Pareto coefficients from raw RLMS output****/ 
clear;
set obs 1;
gen b="b(0.9)";
export excel b using Gpinter\Output\RawSurveySeriesRLMS.xlsx, sheet("series",modify) cell(J1);
clear;
import excel Gpinter\Output\RawSurveySeriesRLMS.xlsx, sheet("survey income, Russia, 1994") firstrow;
keep if p==0.9;
keep b;
gen year=1994;
save Gpinter/Output/Temp/b.dta, replace;
forvalues year=1995/2015 
{;
clear;
import excel Gpinter\Output\RawSurveySeriesRLMS.xlsx, sheet("survey income, Russia, `year'") firstrow;
keep if p==0.9;
keep b;
gen year=`year';
append using Gpinter/Output/Temp/b.dta;
save Gpinter/Output/Temp/b.dta, replace;
};
sort year;
export excel b using Gpinter\Output\RawSurveySeriesRLMS.xlsx, sheet("series",modify) cell(J2);
*/

/****Step 2: extracting Pareto coefficients from tax corrected RLMS output****/ 
clear;
set obs 1;
gen b="b(0.9)";
export excel b using Gpinter\Output\CorrectedSurveySeriesRLMSTax.xlsx, sheet("series",modify) cell(J1);
clear;
import excel Gpinter\Output\CorrectedSurveySeriesRLMSTax.xlsx, sheet("v21, Russia, 2008") firstrow;
keep if p==0.9;
keep b;
gen year=2008;
save Gpinter/Output/Temp/bcorr.dta, replace;
/*****Variants 2.1/2.5*****/
forvalues variant=1/5 
{;
forvalues year=2008/2015 
{;
clear;
import excel Gpinter\Output\CorrectedSurveySeriesRLMSTax.xlsx, sheet("v2`variant', Russia, `year'") firstrow;
keep if p==0.9;
keep b;
gen year=`year';
gen v=20+`variant';
append using Gpinter/Output/Temp/bcorr.dta;
save Gpinter/Output/Temp/bcorr.dta, replace;
};
};
/*****Variants 3.1/3.4*****/
forvalues variant=1/4 
{;
forvalues year=2008/2015 
{;
clear;
import excel Gpinter\Output\CorrectedSurveySeriesRLMSTax.xlsx, sheet("v3`variant', Russia, `year'") firstrow;
keep if p==0.9;
keep b;
gen year=`year';
gen v=30+`variant';
append using Gpinter/Output/Temp/bcorr.dta;
save Gpinter/Output/Temp/bcorr.dta, replace;
};
};
sort v year;
drop if v==.;
export excel b using Gpinter\Output\CorrectedSurveySeriesRLMSTax.xlsx, sheet("series",modify) cell(J2);


