/*******Stata code  WID.world gpinter*****/

#delimit;
clear;
set more off;

cd "D:\Users\t.piketty\Dropbox\WIDRussia\NPZ2017DistributionSeries\";


/*


/*****Step 1: Importing distributions of fiscal income, normalizing and reexporting**/
foreach year in 1905 1928 1934 1956 1959 1961 1964 1966 1968 1972 1976 1980 1985
{;
clear;
import excel Gpinter\Output\FinalSeries.xlsx, sheet("yf, Russia, `year'") firstrow;
keep year country component average p thr b;
keep if p<=0.99 | p==0.999 | p==0.9999 | p==0.99999;
append using Gpinter\IncomeParameters.dta;
keep if year2==. | year2==`year';
egen yfa=max(yf);
gen ratio=yfa/average; 
egen ratioa=max(ratio);
keep if year2==.;
replace thr=thr*ratioa;
replace average=average*ratioa;
drop if p==.;
keep year country component average p thr b;
export excel using Gpinter\Input\FinalTabulationsCopula.xlsx, sheet("`year'yf") sheetreplace firstrow(variables);
clear;
};
forvalues year=1988/2015
{;
clear;
import excel Gpinter\Output\FinalSeries.xlsx, sheet("yf, Russia, `year'") firstrow;
keep year country component average p thr b;
keep if p<=0.99 | p==0.999 | p==0.9999 | p==0.99999;
append using Gpinter\IncomeParameters.dta;
keep if year2==. | year2==`year';
egen yfa=max(yf);
gen ratio=yfa/average; 
egen ratioa=max(ratio);
keep if year2==.;
replace thr=thr*ratioa;
replace average=average*ratioa;
drop if p==.;
keep year country component average p thr b;
export excel using Gpinter\Input\FinalTabulationsCopula.xlsx, sheet("`year'yf") sheetreplace firstrow(variables);
clear;
};


/*****Step 2: Importing distributions of non-fiscal income, normalizing and reexporting**/
foreach year in 1905 1928 1934 1956 1959 1961 1964 1966 1968 1972 1976 1980 1985 1988 1989 1990 1991 1992 1993 1994
{;
clear;
import excel GpinterWealth\Output\WealthSeriesRussiaBenchmark.xlsx, sheet("wealth, Russia, 1995") firstrow;
keep year country component average p thr b;
keep if p<=0.99 | p==0.999 | p==0.9999 | p==0.99999;
append using Gpinter\IncomeParameters.dta;
keep if year2==. | year2==`year';
egen ynfa=max(ynf);
gen ratio=ynfa/average; 
egen ratioa=max(ratio);
keep if year2==.;
replace thr=thr*ratioa;
replace average=average*ratioa;
drop if p==.;
replace year="`year'";
replace component="ynf";
keep year country component average p thr b;
export excel using Gpinter\Input\FinalTabulationsCopula.xlsx, sheet("`year'ynf") sheetreplace firstrow(variables);
clear;
};
forvalues year=1995/2015
{;
clear;
import excel GpinterWealth\Output\WealthSeriesRussiaBenchmark.xlsx, sheet("wealth, Russia, `year'") firstrow;
keep year country component average p thr b;
keep if p<=0.99 | p==0.999 | p==0.9999 | p==0.99999;
append using Gpinter\IncomeParameters.dta;
keep if year2==. | year2==`year';
egen ynfa=max(ynf);
gen ratio=ynfa/average; 
egen ratioa=max(ratio);
keep if year2==.;
replace thr=thr*ratioa;
replace average=average*ratioa;
drop if p==.;
replace component="ynf";
keep year country component average p thr b;
export excel using Gpinter\Input\FinalTabulationsCopula.xlsx, sheet("`year'ynf") sheetreplace firstrow(variables);
clear;
};



*/

/*****Step 3: variants for alternative wealth distributions*****/ 
/*****Importing distributions of fiscal income, normalizing and reexporting**/
foreach nadult in 2 4 6 8 
{;
foreach year in 1980 1985 1988 1989 1990 1991 1992 1993 1994
{;
clear;
import excel Gpinter\Output\FinalSeries.xlsx, sheet("yf, Russia, `year'") firstrow;
keep year country component average p thr b;
keep if p<=0.99 | p==0.999 | p==0.9999 | p==0.99999;
append using Gpinter\IncomeParameters.dta;
keep if year2==. | year2==`year';
egen yfa=max(yf);
gen ratio=yfa/average; 
egen ratioa=max(ratio);
keep if year2==.;
replace thr=thr*ratioa;
replace average=average*ratioa;
drop if p==.;
keep year country component average p thr b;
export excel using Gpinter\Input\FinalTabulationsCopulaVariantn`nadult'.xlsx, sheet("`year'yf") sheetreplace firstrow(variables);
clear;
import excel GpinterWealth\Output\WealthSeriesRussiaVariants1.xlsx, sheet("wealth, Russia, `nadult'1995") firstrow;
keep year country component average p thr b;
keep if p<=0.99 | p==0.999 | p==0.9999 | p==0.99999;
append using Gpinter\IncomeParameters.dta;
keep if year2==. | year2==`year';
egen ynfa=max(ynf);
gen ratio=ynfa/average; 
egen ratioa=max(ratio);
keep if year2==.;
replace thr=thr*ratioa;
replace average=average*ratioa;
drop if p==.;
replace year="`year'";
replace component="ynf";
keep year country component average p thr b;
export excel using Gpinter\Input\FinalTabulationsCopulaVariantn`nadult'.xlsx, sheet("`year'ynf") sheetreplace firstrow(variables);
};

forvalues year=1995/2015
{;
clear;
import excel Gpinter\Output\FinalSeries.xlsx, sheet("yf, Russia, `year'") firstrow;
keep year country component average p thr b;
keep if p<=0.99 | p==0.999 | p==0.9999 | p==0.99999;
append using Gpinter\IncomeParameters.dta;
keep if year2==. | year2==`year';
egen yfa=max(yf);
gen ratio=yfa/average; 
egen ratioa=max(ratio);
keep if year2==.;
replace thr=thr*ratioa;
replace average=average*ratioa;
drop if p==.;
keep year country component average p thr b;
export excel using Gpinter\Input\FinalTabulationsCopulaVariantn`nadult'.xlsx, sheet("`year'yf") sheetreplace firstrow(variables);
clear;
import excel GpinterWealth\Output\WealthSeriesRussiaVariants1.xlsx, sheet("wealth, Russia, `nadult'`year'") firstrow;
keep year country component average p thr b;
keep if p<=0.99 | p==0.999 | p==0.9999 | p==0.99999;
append using Gpinter\IncomeParameters.dta;
keep if year2==. | year2==`year';
egen ynfa=max(ynf);
gen ratio=ynfa/average; 
egen ratioa=max(ratio);
keep if year2==.;
replace thr=thr*ratioa;
replace average=average*ratioa;
drop if p==.;
replace component="ynf";
replace year="`year'";
keep year country component average p thr b;
export excel using Gpinter\Input\FinalTabulationsCopulaVariantn`nadult'.xlsx, sheet("`year'ynf") sheetreplace firstrow(variables);
clear;
};
};

