/*******Stata code generating normalized WID.world top-percentile wealth distributions US-CH-FR using gpinter*****/

#delimit;
clear;
set more off;

cd "D:\Users\t.piketty\Dropbox\WIDRussia\NPZ2017DistributionSeries\";



/****Step 0 to be added: import directly from WID.world US-FR-Ch distributions**/
/*wid, indicators(thweal bhweal ahweal) years(2014) areas(FR) clear;*/

/*

/****Step 1: importing WID.world normalized USCHFR distributions and restricting to top 1%****/ 
forvalues year=1995/2015
{;
clear;
import excel GpinterWealth\Input\WealthTabulationsWIDworld.xlsx, sheet("`year'") firstrow;
drop if p<0.99;
replace p=(p-0.99)*100;
replace year=`year' if p==0; 
replace country="USCHFR" if p==0; 
replace component="wealth" if p==0;
replace average=topavg if p==0;
export excel using GpinterWealth\Input\WealthTopTabulationsWIDworld.xlsx, sheet("`year'") sheetreplace firstrow(variables);
clear;
};


/****Step 2: apply Gptiner to input file WealthTopTabulationsWIDworld.xlsx to obtain output file WealthTopSeriesWIDworld.xlsx****/

*/

/****Step 3: suppress intermediate thresholds below top 0.1% (otherwise too many thresholds)****/
forvalues year=1995/2015
{;
clear;
import excel GpinterWealth\Output\WealthTopSeriesWIDworld.xlsx, sheet("wealth, USCHFR, `year'") firstrow;
drop if p<0.9 & (p~=0 & p~=0.1 & p~=0.2 & p~=0.3 & p~=0.4 & p~=0.5 & p~=0.6 & p~=0.7 & p~=0.8 & p~=0.9);
replace bracketavg=((1-p)*topavg-(1-p[_n+1])*topavg[_n+1])/(p[_n+1]-p) if p<0.9;
export excel GpinterWealth\Output\WealthTopSeriesWIDworld.xlsx, sheet("wealth, USCHFR, `year'", replace) firstrow(variables);
};

